<?php

namespace Traits\Validator;

use Helpers\Trad\Trad;
use Helpers\Trad\ITrad;

trait Heure
{
    abstract public function getTrad() :ITrad;

    /**
     * Véirife le format heure HH:MM
     *
     * @param bool $obligatoire
     * @return bool
     */
    public function isHours(string $nomChamp, string $value = '', $obligatoire = false) : bool
    {
        if (!$value) {
            if (!$obligatoire) {
                return true;
            }
            $this->validate += 1 ;
            
            // @phpstan-ignore-next-line
            $this->error .= ($nomChamp??'') == ''
                                    ? '<br />'.$this->getTrad()->t("La date est obligatoire.")
                                    : '<br />'.Trad::strBuild($this->getTrad()->t("La champs @1@ est obligatoire."), $nomChamp);
            return false;
        }
        
        if (!preg_match('/^(?:[01][0-9]|2[0-3]):[0-5][0-9]$/', $value)) {
            $this->validate += 1 ;
            $this->error .= '<br />'.Trad::strBuild($this->getTrad()->t('Le champ @1@ n\'est pas valide, il doit être sous forme HH:MM.'), $nomChamp);
            
            return false;
        }
        
        return true;
    }
    
    /**
     * Vérifie le format heure (avec seconde) HH:MM:SS
     *
     * @param string $nomChamp
     * @param string $value
     * @return bool
     */
    public function isHourWithSeconde(string $nomChamp, string $value = '', bool $obligatoire = false) : bool
    {
        if (!$value) {
            if (! $obligatoire) {
                return true;
            }
            $this->validate += 1 ;
            
            // @phpstan-ignore-next-line
            $this->error .= ($nomChamp??'') == ''
                                    ? '<br />'.$this->getTrad()->t("La date est obligatoire.")
                                    : '<br />'.Trad::strBuild($this->getTrad()->t("La champs @1@ est obligatoire."), $nomChamp);
            return false;
        }
        
        if (!preg_match('/^(2[0-3]|[01][0-9]):([0-5][0-9]):([0-5][0-9])$/', $value)) {
            $this->validate += 1 ;
            $this->error .= '<br />'.Trad::strBuild($this->getTrad()->t('Le champ @1@ n\'est pas valide, il doit être sous forme HH:MM:SS.'), $nomChamp);
            
            return false;
        }
        
        return true;
    }
    
    /**
     * Vérifie le format heure (avec seconde) HH:MM:SS
     *
     * @param string $nomChamp
     * @param string $value
     * @return bool
     */
    public function isHourWithSecondeCC(string $nomChamp, string $value = '', bool $obligatoire = false) : bool
    {
        if (!$value) {
            if (! $obligatoire) {
                return true;
            }
            $this->validate += 1 ;

            // @phpstan-ignore-next-line
            $this->error .= ($nomChamp??'') == ''
                                    ? '<br />'.$this->getTrad()->t("La date est obligatoire.")
                                    : '<br />'.Trad::strBuild($this->getTrad()->t("La champs @1@ est obligatoire."), $nomChamp);
            return false;
        }

        $checkedValue = str_replace(':', '', $value);
        
        if (!preg_match('/^(2[0-3]|[01][0-9])([0-5][0-9])([0-5][0-9])$/', $checkedValue)) {
            $this->validate += 1 ;
            $this->error .= '<br />'.Trad::strBuild($this->getTrad()->t('Le champ @1@ n\'est pas valide, il doit être sous forme HH:MM:SS ou HHMMSS.'), $nomChamp);
            
            return false;
        }
        
        return true;
    }
}
